﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Hotel_Course_Project
{
    /// <summary>
    /// Логика взаимодействия для AdminPage.xaml
    /// </summary>
    public partial class AdminPage : Page
    {
        public AdminPage(Staff admin)
        {
            InitializeComponent();
        }

        private void Page_Loaded(object sender, RoutedEventArgs e)
        {
            #region условия для выводва работников
            if (SortStaffCB.SelectedItem == activeS)
            {
                StaffList.ItemsSource = DataBase.db.Staff.Where(item => item.Id_PersStatus == 1).ToList();
            }
            else
            {
                StaffList.ItemsSource = DataBase.db.Staff.Where(item => item.Id_PersStatus == 2).ToList();
            }
            #endregion
            #region Условия для выводва клиентов
            if (SortClientCB.SelectedItem == activeC)
            {
                ClientList.ItemsSource = DataBase.db.Client.Where(item => item.Id_PersStatus == 1).ToList();
            }
            else
            {
                ClientList.ItemsSource = DataBase.db.Client.Where(item => item.Id_PersStatus == 2).ToList();
            }
            #endregion

            RoomList.ItemsSource = DataBase.db.Room.ToList();
        }

        #region Обработчики кнопок добавления
        private void AddStaffBtn_Click(object sender, RoutedEventArgs e)
        {
            PChanger.MainFrame.Navigate(new StaffChangeOrAddPage(null));
            Page_Loaded(sender, e);
        }
        private void AddClientBtn_Click(object sender, RoutedEventArgs e)
        {
            PChanger.MainFrame.Navigate(new ClientChangeOrAddPage(null));
            Page_Loaded(sender, e);
        }

        #endregion

        #region Обработчики  кнопок выбора
        private void StaffSelectBtn_Click(object sender, RoutedEventArgs e)
        {
            Staff staff = (sender as Button).DataContext as Staff;
            PChanger.MainFrame.Navigate(new StaffChangeOrAddPage(staff));
            Page_Loaded(sender, e);
        }
        private void ClientSelectBtn_Click(object sender, RoutedEventArgs e)
        {
            Client client = (sender as Button).DataContext as Client;
            PChanger.MainFrame.Navigate(new ClientChangeOrAddPage(client));
            Page_Loaded(sender, e);
        }
        #endregion

        #region Обработчики выбора в сортировке

        private void SortStaffCB_SelectionChanged(object sender, RoutedEventArgs e)
        {
            if (StaffList != null)
            {
                Page_Loaded(sender, e);
            }
        }

        private void SortClientCB_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (ClientList != null)
            {
                Page_Loaded(sender, e);
            }
        }

        #endregion

        #region Обработчики кнопок поиска
        private void StaffSrchBtn_Click(object sender, RoutedEventArgs e)
        {
            var seacrhed = DataBase.db.Staff.Where(item => (item.LName + " " + item.FName + " " + item.MName + " " + item.Login + " " + item.Password).Contains(StaffSeacrhTB.Text)).ToList();
            if (SortStaffCB.SelectedItem == activeS)
            {
                StaffList.ItemsSource = seacrhed.Where(item => item.Id_PersStatus == 1).ToList();
            }
            else
            {
                StaffList.ItemsSource = seacrhed.Where(item => item.Id_PersStatus == 2).ToList();
            }
        }

        private void ClientSrchBtn_Click(object sender, RoutedEventArgs e)
        {
            var seacrhed = DataBase.db.Client.Where(item => (item.LName + " " + item.FName + " " + item.MName).Contains(ClientSeacrhTB.Text)).ToList();
            if (SortClientCB.SelectedItem == activeC)
            {
                ClientList.ItemsSource = seacrhed.Where(item => item.Id_PersStatus == 1).ToList();
            }
            else
            {
                ClientList.ItemsSource = seacrhed.Where(item => item.Id_PersStatus == 2).ToList();
            }
        }
        #endregion

        #region Обработичики изменений видов сортировки
        private void StaffSeacrhTB_TextChanged(object sender, TextChangedEventArgs e)
        {
            if (StaffSeacrhTB.Text == "")
            {
                Page_Loaded(sender, e);
            }
        }
        private void ClientSeacrhTB_TextChanged(object sender, TextChangedEventArgs e)
        {
            if (ClientSeacrhTB.Text == "")
            {
                Page_Loaded(sender, e);
            }
        }
        #endregion

        private void AddRoomBtn_Click(object sender, RoutedEventArgs e)
        {
            RoomAddOrChangePage roomAddOrChange = new RoomAddOrChangePage(null);
            PChanger.MainFrame.Navigate(new RoomAddOrChangePage(null));
            Page_Loaded(sender, e);
        }

        private void SelectRoomBtn_Click(object sender, RoutedEventArgs e)
        {
            Room room = (sender as Button).DataContext as Room;
            PChanger.MainFrame.Navigate(new RoomAddOrChangePage(room));
            Page_Loaded(sender, e);
        }
    }
}
